#include <string>

#include "menu.h"

#include "../common.h"

using namespace std;

menu::menu()
{
	background = load_bitmap("images/menubg.pcx", NULL);

	pointer    = load_bitmap("images/pointer.pcx", NULL);

	game_won_gfx   = load_bitmap("images/game_won.pcx", NULL);

	level_won_gfx  = load_bitmap("images/level_won.pcx", NULL);
	level_lost_gfx = load_bitmap("images/level_lost.pcx", NULL);

	menu_newgame    = load_bitmap("images/menu_newgame.pcx", NULL);
	menu_resumegame = load_bitmap("images/menu_resumegame.pcx", NULL);
	menu_exit       = load_bitmap("images/menu_exit.pcx", NULL);   


}

menu::~menu()
{
	destroy_bitmap(background);
	destroy_bitmap(pointer);

	destroy_bitmap(game_won_gfx);

	destroy_bitmap(level_won_gfx);
	destroy_bitmap(level_lost_gfx);

	destroy_bitmap(menu_newgame);
	destroy_bitmap(menu_resumegame);
	destroy_bitmap(menu_exit);
}

void menu::render()
{
	if(level_over)
	{
		if(game_won)
		  render_game_won();
		else if(level_won)
			render_level_won();
		else if(level_lost)
			render_level_lost();
	}

	else
	{

		blit(background, buffer, 0, 0, 0, 0, SCREEN_W, SCREEN_H);	

		masked_blit(menu_newgame,    buffer, 0, 0, 400, 200, SCREEN_W, SCREEN_H);	
		masked_blit(menu_resumegame, buffer, 0, 0, 400, 250, SCREEN_W, SCREEN_H);	
		masked_blit(menu_exit,       buffer, 0, 0, 400, 300, SCREEN_W, SCREEN_H);	
	
		if(selection != 0)
			masked_blit(pointer, buffer, 0, 0, 350, 150 + selection * 50, 32, 32);
		masked_blit(arrow, buffer, 0, 0, mouse_x, mouse_y, 32, 32);

		//textprintf_ex(buffer, font, 10, 10, makecol(255, 255, 255), 0, "Mx: %i My: %i", mouse_x, mouse_y);
	}
}

void menu::render_level_won()
{
		//grey(buffer);

		blit(level_won_gfx, buffer, 0, 0, SCREEN_W / 2 - level_won_gfx->w / 2, SCREEN_H / 2 - level_won_gfx->h / 2, level_won_gfx->w, level_won_gfx->h);	

		//textprintf_ex(buffer, font, 10, 10, makecol(255, 255, 255), 0, "WON!!! Mx: %i My: %i", mouse_x, mouse_y);	
}

void menu::render_level_lost()
{
		//grey(buffer);

		blit(level_lost_gfx, buffer, 0, 0, SCREEN_W / 2 - level_lost_gfx->w / 2, SCREEN_H / 2 - level_lost_gfx->h / 2, level_lost_gfx->w, level_lost_gfx->h);	

		//textprintf_ex(buffer, font, 10, 10, makecol(255, 255, 255), 0, "LOST!!! Mx: %i My: %i", mouse_x, mouse_y);	
}

void menu::render_game_won()
{

		blit(game_won_gfx, buffer, 0, 0, SCREEN_W / 2 - game_won_gfx->w / 2, SCREEN_H / 2 - game_won_gfx->h / 2, game_won_gfx->w, game_won_gfx->h);	

}


void menu::update()
{
	if(level_over)
	{
		if(game_won)
			update_game_won();
		else if(level_won)
			update_level_won();
		else if(level_lost)
			update_level_lost();		

	}
	else
	{


	if(mouse_x > 400 && mouse_y > 200 && mouse_x < 600 && mouse_y < 350)
	{
		selection = (mouse_y - 200) / 50 + 1;
	}
	else
	{
		selection = 0;
	}

	if(mouse_b & 1)
	{
		switch(selection)
		{
			default: break;
			case 3: game_running = false; break;
			case 1: 
				
				strncpy(level_basename, "level", 32);
				level_current = 1;

				level_new = true;

				game_pause = false; 
				menu_show = false;

				break;

			case 2: 
	
				if(map_c != NULL)
				{				
					game_pause = false;
					menu_show = false;
				}
				break;

		}
	}
	}
}

void menu::update_level_lost()
{
	if(keypressed())
	{
		level_new = true;
		game_pause = false;
		level_over = false;
		level_lost = false;
		level_won  = false;
	}
}

void menu::update_level_won()
{
	if(keypressed())
	{
		level_current++;
		level_new = true;
		game_pause = false;
		level_over = false;
		level_lost = false;
		level_won = false;
	}
}

void menu::update_game_won()
{
	if(keypressed() && key[KEY_ESC])
	{
		game_running = false;
		game_pause = false;
		level_over = false;
		level_lost = false;
		level_won = false;
		game_won = false;
	}
}
