#include <cstdlib>

#include "allegro.h"
#include "layer.h"


layer::layer(int x, int y, int w, int h, int t, int a)
{
 TRACE("Layer - Constructor reached\n");
 pos_x = x;
 pos_y = y;

 width = w;
 height = h;

 type = t;
 alpha = a;

 data = NULL;

 create(w, h);
}

layer::~layer()
{
 TRACE("Layer - Deconstructor reached\n");
 if(data)destroy();
}

bool layer::show()
{
 alpha = 255;
 return true;
}

bool layer::hide()
{
 alpha = 0;
 return true;
}

bool layer::alpha_set(int i)
{
 if(i >= 0 && i <= 255)alpha = i;
 return true;
}

int layer::alpha_get()
{
 return alpha;
}


bool layer::create(int w, int h)
{
 TRACE("Layer - create: Trying to create layer\n");
 width = w;
 height = h;

 data = new int *[w];
 
 for(int i = 0; i < w; i++)
 {
  data[i] = new int[h]; 
  for(int j = 0; j < h; j++)
   data[i][j] = 0;
 } 

 TRACE("Layer - create: Layer created (0, 0 = %i)\n", data[0][0]);

 return true;
}

bool layer::destroy()
{
 TRACE("Layer - destroy: Trying to destroy layer\n");
 if(data)
 {
  for(int x = 0; x < width; x++)
   delete [] data[x];
   
  delete [] data;    
  
  data = NULL;
 }
 return true;
}


