#define TILE_W 32
#define TILE_H 32

#ifndef __MAP_H__
#define __MAP_H__

#include <vector>

#include "allegro.h"
#include "layer/layer.h"
#include "tileset/tileset.h"

using namespace std;

class map 
{
 private:
 
 int width;
 int height; 
 
 vector<layer *> layers;

 bool destroy();
 bool layer_exists(unsigned int i);



 public:
 
 map();
 virtual ~map();       
 
 
 bool layer_create(int w, int h, int t, int a);
 bool layer_delete(unsigned int i);
 unsigned int  layer_count();
 
 bool load(const char *filename);
 bool save(const char *filename);
 
 bool render(BITMAP *target, tileset *t, int xo, int yo);
 
 bool set(unsigned int l, int x, int y, int n);
 int  get(unsigned int l, int x, int y);
 


 layer *operator[] (unsigned int i){ return layers[i]; }
      
};

#endif
